-- {13.1.19.8684_13.2.539.8684}
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO


if  exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[CheckClassInVersion]') and xtype in (N'FN', N'IF', N'TF'))
	drop function [dbo].[CheckClassInVersion]
GO



--     
create function [dbo].[CheckClassInVersion] (@nVerId int, @nClId int)
	returns int
as
begin

declare @nDictVersion int, @nRet int, @nParentClassId int

select @nParentClassId = cp.SourceClassificatorId from ClassificatorProperty cp where cp.ClassificatorID = @nClId

if isnull(@nParentClassId,0) > 0
	select @nClId = @nParentClassId

if exists (select * from T_VERSION where VersionID = @nVerId and ClassificatorID = @nClId)
	select @nRet = case when T_VERSION.Deleted = 0 then 1 else 0 end from T_VERSION where VersionID = @nVerId and ClassificatorID = @nClId
else
	begin
		select @nDictVersion = dbo.obj_id('DICTIONARY_VERSION')

		declare @V table (ORDERS int identity, VERSIONID int)
		declare @V1 table (VERSIONID int, CLASSIFICATORID int, ORDERS int, DELETED int)
		

		--    
		insert @V (VERSIONID) select A.LINK from dbo.[TREE_VERSION](@nVerId, 'UP') A, VERSION V where A.LINK = V.VERSIONID and V.OBJECT = @nDictVersion
--select * from @V
		insert @V1 (VERSIONID, CLASSIFICATORID, ORDERS)
		select TV.VERSIONID, TV.CLASSIFICATORID, max(V.ORDERS)
		from @V V, T_VERSION TV
		where V.VERSIONID = TV.VERSIONID and TV.CLASSIFICATORID = @nClId
		group by TV.VERSIONID, TV.CLASSIFICATORID

		update @V1 set DELETED = TV.DELETED from @V1 V1, @V V, T_VERSION TV
		where V1.CLASSIFICATORID = TV.CLASSIFICATORID and V.ORDERS = V1.ORDERS and TV.VERSIONID = V.VERSIONID
		
--select * from @V1
		if exists (select * from @V1)
			delete @V where ORDERS > (select max(ORDERS) from @V1 where DELETED = 1)
		else
			delete @V

--select * from @V

		if exists(select * from @V where VERSIONID = @nVerId)
			select @nRet = 1
		else
			select @nRet = 0
	end

	return @nRet

end


GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8650' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'FUNCTION',@level1name=N'CHECKCLASSINVERSION'
GO



IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[CubeName]') AND xtype in (N'FN', N'IF', N'TF'))
DROP FUNCTION [dbo].[CubeName]
GO


--   
create function [dbo].[CubeName] (@nVerId int)
	returns varchar(200)
as
begin

declare @cCubeName varchar(200), @nProj int, @nObj int, @nObj1 int, @nObj2 int, @nObj3 int, @nObj4 int, @nObjVer int
select @nObjVer = V.[OBJECT] from VERSION V where V.VersionID = @nVerId
select @nObj = dbo.obj_id('DICTIONARY_PROJECT')
select @nObj1 = dbo.obj_id('DICTIONARY_ALGORITHM_DWH')
select @nObj2 = dbo.obj_id('DICTIONARY_DATASOURCE')
select @nObj3 = dbo.obj_id('DICTIONARY_REPORT_TEMPLATE')
select @nObj4 = dbo.obj_id('DICTIONARY_PROJECT_EXT')

if @nObjVer = @nObj2 or @nObjVer = @nObj3
	select @nProj = PARENTID from T_RELATION TR inner join VERSION V on TR.PARENTID = V.VersionID and TR.CHILDID = @nVerId and V.[OBJECT] = @nObj

if @nObjVer = @nObj1
	select @nProj = PARENTID from T_RELATION TR inner join VERSION V on TR.PARENTID = V.VersionID and TR.CHILDID = @nVerId and V.[OBJECT] = @nObj
else
	select @nProj = PARENTID from T_RELATION TR inner join VERSION V on TR.PARENTID = V.VersionID and TR.CHILDID = @nProj and V.[OBJECT] = @nObj

if @nObjVer = @nObj or @nObjVer = @nObj4
	begin
		select @cCubeName = 'CUBE_' + convert(varchar(20), @nVerId)
	end
else
	begin
		select @nProj = PARENTID from T_RELATION TR inner join VERSION V on TR.PARENTID = V.VersionID and TR.CHILDID = @nProj and V.[OBJECT] = @nObj
		select @cCubeName = 'CUBE_' + convert(varchar(20), @nProj)
	end
	
return @cCubeName

end
GO






exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8045' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'FUNCTION',@level1name=N'CUBENAME'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sklon_str_nleft]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[sklon_str_nleft]
GO


-- rev 1.1
CREATE  function [dbo].[sklon_str_nleft] (@cVal varchar(8000), @nPad int, @nleft int)
	returns varchar(8000) as
begin
	declare @cRes varchar(8000), @cSkl varchar(8000), @cNotSkl varchar(8000), @n int

	select @n = patindex('%[/,\,.,!,?,(,),;,:, ,,,-]%', @cVal), @cSkl='', @cNotSkl=@cVal
	while @nleft>0
	begin
		if @n>0
			select @cSkl = @cSkl + left(@cNotSkl, @n), @cNotSkl = substring(@cNotSkl, @n+1, 8000)
		else
			select @cSkl = @cSkl + @cNotSkl, @cNotSkl = ''
		select @nleft=@nleft-1, @n = patindex('%[/,\,.,!,?,(,),;,:, ,,,-]%', @cNotSkl)
	end

	exec master..xp_sklonstr @cSkl,@nPad,@cRes output
	return isnull(@cRes,'')+isnull(@cNotSkl,'')
end
GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8106' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'FUNCTION',@level1name=N'SKLON_STR_NLEFT'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[sklon_str]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
DROP FUNCTION [dbo].[sklon_str]
GO

-- rev 1.1
CREATE  function [dbo].[sklon_str] (@cVal varchar(8000), @nPad int)
	returns varchar(8000) as
begin
	declare @cRes varchar(8000)
	exec master..xp_sklonstr @cVal,@nPad,@cRes output
	return @cRes
end
GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'8106' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'FUNCTION',@level1name=N'SKLON_STR'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[GetMeasureXML]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
	DROP FUNCTION [dbo].[GetMeasureXML]
GO

/*
:
	       XML
	   
	
:
	@cObject -  -
	@cName -  MeasureGroups,
	@cFacts -  .  
	
 :
	select dbo.GetMeasureXML('KS_DDLControl.FACTS_2248','','KS_DDLControl.FACTS2_2248')
	select dbo.GetMeasureXML('KS_DDLControl.FACTS2_2248','KS_DDLControl.FACTS2_2248','KS_DDLControl.FACTS_2248')

:
	xxxx					- id 
	yyyy					- id 
	zzzz					- id 
	
	FACTS_xxxx				-   
	FACTS_xxxx_yyyy			-    
	FACTS2_xxxx				-       
	FACTS2_xxxx_yyyy		-      ,   
	FACTS2_xxxx_yyyy_zzzz	-     / ,      
	CL_xxxx_zzzz			-   
	CLD_xxxx				-   
	TIME_xxxx				-  
	CLA_xxxx_zzzz			-    
	
:  .
*/

create function [dbo].[GetMeasureXML] (@cObject varchar(128), @cName varchar(64), @cFacts varchar(4000))
	returns varchar(max)
as
begin
	declare @cRet varchar(max), @nObjId int, @cTable varchar(128), @cProj varchar(20)
	
	if object_id(@cObject) is null
		begin
			select @cRet = ''			
		end
	else
		begin
			declare @tObject table ([object_id] int, name varchar(256))

			select @nObjId = object_id(@cObject)
			
			select @cTable = so.name from sys.objects so where so.[object_id] = @nObjId
			select @cProj = dbo.j_sub_str(@cTable,'_',2)

			select @cRet = '<MeasureGroup Name="' +
			case
				when @cTable like 'CL%' then replace(replace(replace(@cFacts,'[', ''),']', ''),'CL','CLA')
				else
					@cTable
			end + '" Caption="' +
			case
				when @cTable like 'CL%' then replace(replace(replace(@cFacts,'[', ''),']', ''),'CL','CLA')
				else
					@cName
			end + '"><Table>' + @cTable + '</Table>'

			--   
			select @cRet = @cRet + isnull((
			select
			'<Dimension><Type>Regular</Type>' + 
				case
					when sc.name = 'VERSIONID' then '<CubeDimensionId>CLD_' + @cProj + '</CubeDimensionId><Column>VERSIONID</Column>' -- 
					when sc.name = 'CLH_' + @cProj then '<CubeDimensionId>CLH_' + @cProj + '</CubeDimensionId><Column>CLH_' + @cProj + '</Column>' --  
					when sc.name = 'TIMEKEY' then '<CubeDimensionId>TIME</CubeDimensionId><Column>TIMEKEY</Column>' -- 
					when sc.name = 'UID' then '<CubeDimensionId>USERS_' + @cProj + '</CubeDimensionId><Column>UID</Column>' -- 
					when sc.name = 'CLASSIFICATORID' then '<CubeDimensionId>' + replace(replace(@cFacts,'[', ''),']', '') + '</CubeDimensionId><Column>CLASSIFICATORID</Column>' -- 
					else '<CubeDimensionId>' + sc.name + '</CubeDimensionId><Column>' + sc.name + '</Column>' 
				end + '</Dimension>' as [text()]
			from sys.columns sc
			where
				sc.[object_id] = @nObjId and
				not sc.name like 'MEASURE_%' and
				not sc.name in ('STORAGEID','FILTERID','STRID','ORD') and
				not sc.name like 'ORDERS[_]%' and
				not sc.name like 'CLL[_]%'
			for xml path(''),type).value('.','varchar(max)'),'')

			--   
			if isnull(@cFacts,'') <> '' and @cTable like 'FACTS[_]%'
				begin
					select @cRet = @cRet + '<Dimension><Type>Regular</Type><CubeDimensionId>' + @cTable + '</CubeDimensionId><Column>ORD</Column></Dimension>'
					
					delete @tObject
										
					insert @tObject (name) select value from dbo.StrSplit (@cFacts, ',')
					update @tObject set [object_id] = object_id(name)
					
					select @cRet = @cRet + isnull((
					select '<Dimension><Type>ManyToMany</Type><CubeDimensionId>' + sc.name + '</CubeDimensionId><MeasureGroupId>' + so.name + '</MeasureGroupId></Dimension>' as [text()]
					from @tObject t, sys.columns sc, sys.objects so
					where
						so.[object_id] = sc.[object_id] and so.[object_id] = t.[object_id] and
						not sc.name in ('FILTERID','STRID','ORD') and
						not sc.name like 'ORDERS[_]%'
					for xml path(''),type).value('.','varchar(max)'),'')
				end
			
			--  .  
			if isnull(@cFacts,'') <> '' and @cTable like 'FACTS2[_]%'
				begin
					select @cFacts = replace(replace(replace(@cFacts,'[',''),']',''),'KS_DDLControl.','')
					select @cRet = @cRet + '<Dimension><Type>Regular</Type><CubeDimensionId>' + @cFacts + '</CubeDimensionId><Column>ORD</Column></Dimension>'
				end
								
			-- 
			if @cTable like 'CLA[_]%'
				begin
					select @cRet = @cRet + '<Measure Name="' + replace(replace(replace(@cFacts,'[', ''),']', ''),'CL','CLA') + ' Count" Caption="' + replace(replace(replace(@cFacts,'[', ''),']', ''),'CL','CLA') + ' Count">
					<Column>' +  + @cTable + ' Count</Column>
					<AggregateFunction>Count</AggregateFunction>
					<Visible>false</Visible>
					<DataType Base="Int" />
					</Measure>'
				end
			else
				begin
					select @cRet = @cRet + isnull((
					select 
						'<Measure Name="' + sc.name + '" Caption="' + (select isnull(dbo.[ReplForXml](FULLNAME),'   ') from dbo.MEASURES where MEASUREID = dbo.j_sub_str(sc.name,'_',3)) + '">
						<Column>' + sc.name + '</Column>
						<AggregateFunction></AggregateFunction>
						<Format>#,#0.00</Format>
						<DataType Base="Double" />
						</Measure>' as [text()]
					from sys.columns sc
					where sc.[object_id] = @nObjId and sc.name like 'MEASURE_%'
					for xml path(''),type).value('.','varchar(max)'),'')
				end
			

			select @cRet = @cRet + '</MeasureGroup>'
		end	

	return isnull(@cRet, '')

end


GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'7941' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'FUNCTION',@level1name=N'GETMEASUREXML'
GO



IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[dbo].[GetObjectStruXML]') AND type in (N'FN', N'IF', N'TF', N'FS', N'FT'))
	DROP FUNCTION [dbo].[GetObjectStruXML]
GO

/*
:
	       XML
	   
:
	@cObject -  -
	@nMode - 1 =  <Dsv>; 2 =  <MeasureGroups>; 3 =  <Dimensions>'
	
 :
	select dbo.GetObjectStruXML('[KS_DDLControl].CL_1973_663192',1)
	select dbo.GetObjectStruXML('CL_1973_663192',1)
	select dbo.GetObjectStruXML('[KS_DDLControl].FACTS_1973_1813',2)
	select dbo.GetObjectStruXML('[KS_DDLControl].CL_1973_663192',3)
	select dbo.GetObjectStruXML('[KS_DDLControl].FACTS_1973_1813',3)
	
:  .
*/

create function [dbo].[GetObjectStruXML] (@cObject varchar(128), @nMode int)
	returns varchar(max)
as
begin
	declare @cRet varchar(max), @nObjId int, @cCaption varchar(1000), @cId varchar(20), @cTable varchar(128), @cObject_orig varchar(1000)
	
	if @nMode = 3
		begin
			select @cTable = dbo.j_sub_str(replace(replace(@cObject,']',''),'[',''),'.',2)
			select @cId = isnull(nullif(dbo.j_sub_str(@cTable,'_',3),''),dbo.j_sub_str(@cTable,'_',2))
			select @cObject_orig = ''
			
			if dbo.j_sub_str(@cTable,'_',4)<>''
				begin
					select @cObject_orig = @cObject
					--select @cObject = replace(@cObject_orig, ('_' + dbo.j_sub_str(@cTable,'_',4)),'')
					select @cObject = '[KS_DDLControl].[CL_' + dbo.j_sub_str(@cTable,'_',2) + '_' + dbo.j_sub_str(@cTable,'_',3) + ']'
				end
		end
		
	
	if object_id(@cObject) is null
		begin
			select @cRet = ''
		end
	else
		begin
			select @nObjId = object_id(@cObject)
			
			if @nMode = 1
				begin
					select @cRet = '<Table Schema="' + ss.name + '" Name="' + so.name + '" Expression="">' from sys.objects so, sys.schemas ss where so.[schema_id] = ss.[schema_id] and so.[object_id] = @nObjId

					select @cRet = @cRet + (
					select
					'<Column Name="' +
						case
							when ss.name = 'int' then sc.name + '"><DataType Base="int" />'
							when ss.name = 'money' or ss.name = 'decimal' or ss.name = 'numeric' then sc.name + '"><DataType Base="decimal" />'
							when ss.name = 'varchar' then sc.name + '"><DataType Base="string" Length="' + convert(varchar(20),sc.max_length) + '" />'
						end + '</Column>' as [text()]
					from sys.columns sc inner join sys.systypes ss on ss.xtype = sc.user_type_id
					where sc.[object_id] = @nObjId
					for xml path(''),type).value('.','varchar(max)')

					select @cRet = @cRet + '</Table>'
				end


			if @nMode = 3
				begin

					select @cCaption = 
					case 
						when @cTable like 'CLM[_]%' then (select isnull(FULLNAME, '_' + convert(varchar(20), MEASUREID)) from dbo.MEASURES where MEASUREID = @cId)
						when @cTable like 'CL[_]%' and @cObject_orig = '' then (select isnull(NAME, '_' + convert(varchar(20), @cId)) from dbo.Classificators where ClassificatorID = @cId)
						--when @cTable like 'CL[_]%' and dbo.j_sub_str(@cTable,'_',4)<>'' then (select isnull(NAME, '_' + convert(varchar(20), @cId)) from dbo.Classificators where ClassificatorID = @cId) + ' (' + (select isnull(NAME, '_' + convert(varchar(20), VERSIONID)) from dbo.VERSION where VERSIONID = dbo.j_sub_str(@cTable,'_',4)) + ')'
						when @cTable like 'CL[_]%' and @cObject_orig <> '' and exists(select * from dbo.SOURCETEMPLATE where ClassificatorID = @cId and SourceTemplateID = dbo.j_sub_str(@cTable,'_',4)) then (select TABLENAME from dbo.SOURCETEMPLATE where SourceTemplateID = dbo.j_sub_str(@cTable,'_',4))
						when @cTable like 'CL[_]%' and @cObject_orig <> '' and not exists(select * from dbo.SOURCETEMPLATE where ClassificatorID = @cId and SourceTemplateID = dbo.j_sub_str(@cTable,'_',4)) then (select case when TABLENAME is null then (select name from Classificators c where ST.ClassificatorID = c.ClassificatorID) + ' (' + (select name from Classificators c where @cId = c.ClassificatorID) + ')' else isnull(TABLENAME,'sadsa') + ' (' + (select name from Classificators c where @cId = c.ClassificatorID) + ')' end from dbo.SOURCETEMPLATE ST where ST.SourceTemplateID = dbo.j_sub_str(@cTable,'_',4))
						else (select NAME from dbo.VERSION where VERSIONID = @cId)
					end
					select @cCaption = dbo.[ReplForXml](@cCaption)
						
					select @cRet = '<Dimension Name="' + @cTable + '" Caption="' + @cCaption + '">
					<Table>' + case when @cObject_orig<>'' then 'CL_' + dbo.j_sub_str(@cTable,'_',2) + '_' + dbo.j_sub_str(@cTable,'_',3) else @cTable end + '</Table>
					<Type>' + 
						case
							when @cTable like 'CL[_]%' then (select case isnull(type,1) when 1 then 'Regular' when 2 then 'Hierarchy' when 3 then 'Custom' else 'Regular' end from dbo.Classificators where ParentClassificatorID is null and classificatorid = isnull((select cp.SourceClassificatorId from ClassificatorProperty cp where cp.ClassificatorID = @cId),@cId))
							else 'Regular'
						end + '</Type>
					<Aggregate>' + 
						case
							when @cTable like 'CLM[_]%' or @cTable like 'FACTS[_]%' then 'False'
							else (select case isnull(IsAggregatable,1) when 0 then 'False' else 'True' end from dbo.Classificators where ClassificatorID = @cId)
						end + '</Aggregate>
					<Attributes>'

					select @cRet = @cRet + isnull((select '<Attribute Name="' + @cTable + '" Caption="' + @cCaption + ' - "><Usage>Key</Usage><KeyColumn>CLASSIFICATORID</KeyColumn><NameColumn></NameColumn></Attribute>'
					from sys.columns sc
					where sc.[object_id] = @nObjId and sc.name = 'CLASSIFICATORID'
					for xml path(''),type).value('.','varchar(max)'),'')
						
					select @cRet = @cRet + isnull((select '<Attribute Name="' + 
					case
						when sc.name like 'D_KEY%' then (select dbo.[ReplForXml](NAME) from dbo.ClassificatorDescription where DESCRIPTIONID = dbo.j_sub_str(sc.name,'_',3))
						else sc.name end
					+ '" Caption="' +  
					case
						when sc.name like 'ATTR_NAME%' then @cCaption + (select ' - ' + dbo.[ReplForXml](NAME) from dbo.CLASSIFICATORS_ATTR where CLATTRID = dbo.j_sub_str(sc.name,'_',3))
						when sc.name like 'D_KEY%' then (select dbo.[ReplForXml](NAME) from dbo.ClassificatorDescription where DESCRIPTIONID = dbo.j_sub_str(sc.name,'_',3))
						else @cCaption + ' - ' + sc.name 
					end
					+ '"><Usage>' + 
					case
						when @cTable like 'FACTS[_]%' then 'Key'
						else 'Regular'
					end
					+ '</Usage><KeyColumn>' + 
					sc.name
					+ '</KeyColumn><NameColumn>' + 
					case
						when sc.name like 'D_KEY%' then replace(sc.name,'D_KEY','D_SHOW')
						else sc.name
					end + '</NameColumn></Attribute>'
					from sys.columns sc
					where sc.[object_id] = @nObjId 
						and not sc.name in ('CLASSIFICATORID','PARENTCLASSIFICATORID','','STORAGEID','STRID','FILTERID','TIMEKEY','VERSIONID')
						and not sc.name like 'D_SHOW%'
						and not sc.name like 'CL[_]%'
						and not sc.name like 'CLH[_]%'
						and not sc.name like 'CLM[_]%'
						and not sc.name like 'MEASURE[_]%'
						and not (sc.name like 'ATTR[_]NAME%' and exists (select * from CLASSIFICATORS_ATTR where CLATTRID = dbo.j_sub_str(sc.name,'_',3) and not LINKEDCLASSIFICATORID is null))
					for xml path(''),type).value('.','varchar(max)'),'')

					select @cRet = @cRet + '</Attributes>'
					
					if @cTable like 'CL[_]%' and exists(select 0 from dbo.ClassificatorDescription where classificatorid = isnull((select cp.SourceClassificatorId from ClassificatorProperty cp where cp.ClassificatorID = @cId),@cId) and level > 0)
						begin
							select @cRet = @cRet + '<Hierarchies><Hierarchy Name="H' + @cTable + '" Caption="' + (select top 1 case isnull([type],1) when 1 then '   ' + @cCaption when 2 then '   ' + @cCaption when 3 then ' ' + @cCaption + ':  ' else '' end from classificatordescription where classificatorid = isnull((select cp.SourceClassificatorId from ClassificatorProperty cp where cp.ClassificatorID = @cId),@cId) and level > 0) + '"><All></All>'
							select @cRet = @cRet + '<Type>'+(select convert(varchar(10),isnull([type],0)) from classificators where classificatorid =dbo.j_sub_str(@cTable,'_',3))  +'</Type>'
							
							select @cRet = @cRet + '<Levels>'+
								(	select name as Name, name as Caption, name as AttributeId
									from classificatordescription 
									where classificatorid =	isnull((select cp.SourceClassificatorId from ClassificatorProperty cp where cp.ClassificatorID = @cId),@cId) and level > 0
									order by level
									for xml raw('Level'))	
							select @cRet = @cRet + '</Levels></Hierarchy></Hierarchies>'
						end
					
					select @cRet = @cRet + '</Dimension>'
				end
		end	

	return isnull(@cRet, '')

end


GO




exec dbo.sp_addextendedproperty @name=N'Rev', @value=N'7941' , @level0type=N'USER', @level0name=N'dbo', @level1type=N'FUNCTION',@level1name=N'GETOBJECTSTRUXML'
GO



